JUCE: LookAndFeel_V2 Class Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
LookAndFeel_V2 Class Reference
juce_gui_basics » lookandfeel

This LookAndFeel subclass implements the juce style from around 2008-12. More...

`#include <juce_LookAndFeel_V2.h>`

Inheritance diagram for LookAndFeel_V2:

## Public Member Functions
| LookAndFeel_V2 ()
| ~LookAndFeel_V2 () override
void | drawButtonBackground (Graphics &, Button &, const Colour &backgroundColour, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
Font | getTextButtonFont (TextButton &, int buttonHeight) override
void | drawButtonText (Graphics &, TextButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the text for a TextButton. More...
int | getTextButtonWidthToFitText (TextButton &, int buttonHeight) override
void | drawToggleButton (Graphics &, ToggleButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the contents of a standard ToggleButton. More...
void | changeToggleButtonWidthToFitText (ToggleButton &) override
void | drawTickBox (Graphics &, Component &, float x, float y, float w, float h, bool ticked, bool isEnabled, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
void | drawDrawableButton (Graphics &, DrawableButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
AlertWindow * | createAlertWindow (const String &title, const String &message, const String &button1, const String &button2, const String &button3, MessageBoxIconType iconType, int numButtons, Component *associatedComponent) override
void | drawAlertBox (Graphics &, AlertWindow &, const Rectangle< int > &textArea, TextLayout &) override
int | getAlertBoxWindowFlags () override
Array< int > | getWidthsForTextButtons (AlertWindow &, const Array< TextButton * > &) override
int | getAlertWindowButtonHeight () override
Font | getAlertWindowTitleFont () override
| Override this function to supply a custom font for the alert window title. More...
Font | getAlertWindowMessageFont () override
| Override this function to supply a custom font for the alert window message. More...
Font | getAlertWindowFont () override
void | drawProgressBar (Graphics &, ProgressBar &, int width, int height, double progress, const String &textToShow) override
| Draws a progress bar. More...
void | drawSpinningWaitAnimation (Graphics &, const Colour &colour, int x, int y, int w, int h) override
| Draws a small image that spins to indicate that something's happening. More...
bool | isProgressBarOpaque (ProgressBar &) override
bool | areScrollbarButtonsVisible () override
void | drawScrollbarButton (Graphics &, ScrollBar &, int width, int height, int buttonDirection, bool isScrollbarVertical, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws one of the buttons on a scrollbar. More...
void | drawScrollbar (Graphics &, ScrollBar &, int x, int y, int width, int height, bool isScrollbarVertical, int thumbStartPosition, int thumbSize, bool isMouseOver, bool isMouseDown) override
| Draws the thumb area of a scrollbar. More...
ImageEffectFilter * | getScrollbarEffect () override
| Returns the component effect to use for a scrollbar. More...
int | getMinimumScrollbarThumbSize (ScrollBar &) override
| Returns the minimum length in pixels to use for a scrollbar thumb. More...
int | getDefaultScrollbarWidth () override
| Returns the default thickness to use for a scrollbar. More...
int | getScrollbarButtonSize (ScrollBar &) override
| Returns the length in pixels to use for a scrollbar button. More...
Path | getTickShape (float height) override
| Returns a tick shape for use in yes/no boxes, etc. More...
Path | getCrossShape (float height) override
| Returns a cross shape for use in yes/no boxes, etc. More...
void | drawTreeviewPlusMinusBox (Graphics &, const Rectangle< float > &area, Colour backgroundColour, bool isOpen, bool isMouseOver) override
bool | areLinesDrawnForTreeView (TreeView &) override
int | getTreeViewIndentSize (TreeView &) override
void | fillTextEditorBackground (Graphics &, int width, int height, TextEditor &) override
void | drawTextEditorOutline (Graphics &, int width, int height, TextEditor &) override
CaretComponent * | createCaretComponent (Component *keyFocusOwner) override
const Drawable * | getDefaultFolderImage () override
const Drawable * | getDefaultDocumentFileImage () override
AttributedString | createFileChooserHeaderText (const String &title, const String &instructions) override
void | drawFileBrowserRow (Graphics &, int width, int height, const File &file, const String &filename, Image *icon, const String &fileSizeDescription, const String &fileTimeDescription, bool isDirectory, bool isItemSelected, int itemIndex, DirectoryContentsDisplayComponent &) override
Button * | createFileBrowserGoUpButton () override
void | layoutFileBrowserComponent (FileBrowserComponent &, DirectoryContentsDisplayComponent *, FilePreviewComponent *, ComboBox *currentPathBox, TextEditor *filenameBox, Button *goUpButton) override
void | drawBubble (Graphics &, BubbleComponent &, const Point< float > &tip, const Rectangle< float > &body) override
void | drawLasso (Graphics &, Component &) override
void | drawPopupMenuBackground (Graphics &, int width, int height) override
| Fills the background of a popup menu component. More...
void | drawPopupMenuBackgroundWithOptions (Graphics &, int width, int height, const PopupMenu::Options &) override
| Fills the background of a popup menu component. More...
void | drawPopupMenuItem (Graphics &, const Rectangle< int > &area, bool isSeparator, bool isActive, bool isHighlighted, bool isTicked, bool hasSubMenu, const String &text, const String &shortcutKeyText, const Drawable *icon, const Colour *textColour) override
| Draws one of the items in a popup menu. More...
void | drawPopupMenuItemWithOptions (Graphics &, const Rectangle< int > &area, bool isHighlighted, const PopupMenu::Item &item, const PopupMenu::Options &) override
| Draws one of the items in a popup menu. More...
void | drawPopupMenuSectionHeader (Graphics &, const Rectangle< int > &area, const String &sectionName) override
void | drawPopupMenuSectionHeaderWithOptions (Graphics &, const Rectangle< int > &area, const String &sectionName, const PopupMenu::Options &) override
Font | getPopupMenuFont () override
| Returns the size and style of font to use in popup menus. More...
void | drawPopupMenuUpDownArrow (Graphics &, int width, int height, bool isScrollUpArrow) override
void | drawPopupMenuUpDownArrowWithOptions (Graphics &, int width, int height, bool isScrollUpArrow, const PopupMenu::Options &) override
void | getIdealPopupMenuItemSize (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight) override
| Finds the best size for an item in a popup menu. More...
void | getIdealPopupMenuItemSizeWithOptions (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight, const PopupMenu::Options &) override
| Finds the best size for an item in a popup menu. More...
int | getMenuWindowFlags () override
void | preparePopupMenuWindow (Component &) override
void | drawMenuBarBackground (Graphics &, int width, int height, bool isMouseOverBar, MenuBarComponent &) override
int | getMenuBarItemWidth (MenuBarComponent &, int itemIndex, const String &itemText) override
Font | getMenuBarFont (MenuBarComponent &, int itemIndex, const String &itemText) override
int | getDefaultMenuBarHeight () override
void | drawMenuBarItem (Graphics &, int width, int height, int itemIndex, const String &itemText, bool isMouseOverItem, bool isMenuOpen, bool isMouseOverBar, MenuBarComponent &) override
Component * | getParentComponentForMenuOptions (const PopupMenu::Options &options) override
bool | shouldPopupMenuScaleWithTargetComponent (const PopupMenu::Options &options) override
| Return true if you want your popup menus to scale with the target component's AffineTransform or scale factor. More...
int | getPopupMenuBorderSize () override
int | getPopupMenuBorderSizeWithOptions (const PopupMenu::Options &) override
void | drawPopupMenuColumnSeparatorWithOptions (Graphics &g, const Rectangle< int > &bounds, const PopupMenu::Options &) override
| Implement this to draw some custom decoration between the columns of the popup menu. More...
int | getPopupMenuColumnSeparatorWidthWithOptions (const PopupMenu::Options &) override
| Return the amount of space that should be left between popup menu columns. More...
void | drawComboBox (Graphics &, int width, int height, bool isMouseButtonDown, int buttonX, int buttonY, int buttonW, int buttonH, ComboBox &) override
Font | getComboBoxFont (ComboBox &) override
Label * | createComboBoxTextBox (ComboBox &) override
void | positionComboBoxText (ComboBox &, Label &) override
PopupMenu::Options | getOptionsForComboBoxPopupMenu (ComboBox &, Label &) override
void | drawComboBoxTextWhenNothingSelected (Graphics &, ComboBox &, Label &) override
void | drawLabel (Graphics &, Label &) override
Font | getLabelFont (Label &) override
BorderSize< int > | getLabelBorderSize (Label &) override
void | drawLinearSlider (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &) override
void | drawLinearSliderBackground (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &) override
void | drawLinearSliderThumb (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &) override
void | drawRotarySlider (Graphics &, int x, int y, int width, int height, float sliderPosProportional, float rotaryStartAngle, float rotaryEndAngle, Slider &) override
int | getSliderThumbRadius (Slider &) override
Button * | createSliderButton (Slider &, bool isIncrement) override
Label * | createSliderTextBox (Slider &) override
ImageEffectFilter * | getSliderEffect (Slider &) override
Font | getSliderPopupFont (Slider &) override
int | getSliderPopupPlacement (Slider &) override
Slider::SliderLayout | getSliderLayout (Slider &) override
Rectangle< int > | getTooltipBounds (const String &tipText, Point< int > screenPos, Rectangle< int > parentArea) override
| returns the bounds for a tooltip at the given screen coordinate, constrained within the given desktop area. More...
void | drawTooltip (Graphics &, const String &text, int width, int height) override
Button * | createFilenameComponentBrowseButton (const String &text) override
void | layoutFilenameComponent (FilenameComponent &, ComboBox *filenameBox, Button *browseButton) override
void | drawConcertinaPanelHeader (Graphics &, const Rectangle< int > &area, bool isMouseOver, bool isMouseDown, ConcertinaPanel &, Component &panel) override
void | drawCornerResizer (Graphics &, int w, int h, bool isMouseOver, bool isMouseDragging) override
void | drawResizableFrame (Graphics &, int w, int h, const BorderSize< int > &) override
void | fillResizableWindowBackground (Graphics &, int w, int h, const BorderSize< int > &, ResizableWindow &) override
void | drawResizableWindowBorder (Graphics &, int w, int h, const BorderSize< int > &border, ResizableWindow &) override
void | drawDocumentWindowTitleBar (DocumentWindow &, Graphics &, int w, int h, int titleSpaceX, int titleSpaceW, const Image *icon, bool drawTitleTextOnLeft) override
Button * | createDocumentWindowButton (int buttonType) override
void | positionDocumentWindowButtons (DocumentWindow &, int titleBarX, int titleBarY, int titleBarW, int titleBarH, Button *minimiseButton, Button *maximiseButton, Button *closeButton, bool positionTitleBarButtonsOnLeft) override
std::unique_ptr< DropShadower > | createDropShadowerForComponent (Component &) override
| Creates a drop-shadower for a given component, if required. More...
std::unique_ptr< FocusOutline > | createFocusOutlineForComponent (Component &) override
| Creates a focus outline for a given component, if required. More...
void | drawStretchableLayoutResizerBar (Graphics &, int w, int h, bool isVerticalBar, bool isMouseOver, bool isMouseDragging) override
void | drawGroupComponentOutline (Graphics &, int w, int h, const String &text, const Justification &, GroupComponent &) override
int | getTabButtonSpaceAroundImage () override
int | getTabButtonOverlap (int tabDepth) override
int | getTabButtonBestWidth (TabBarButton &, int tabDepth) override
Rectangle< int > | getTabButtonExtraComponentBounds (const TabBarButton &, Rectangle< int > &textArea, Component &extraComp) override
void | drawTabButton (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown) override
Font | getTabButtonFont (TabBarButton &, float height) override
void | drawTabButtonText (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown) override
void | drawTabbedButtonBarBackground (TabbedButtonBar &, Graphics &) override
void | drawTabAreaBehindFrontButton (TabbedButtonBar &, Graphics &, int w, int h) override
void | createTabButtonShape (TabBarButton &, Path &, bool isMouseOver, bool isMouseDown) override
void | fillTabButtonShape (TabBarButton &, Graphics &, const Path &, bool isMouseOver, bool isMouseDown) override
Button * | createTabBarExtrasButton () override
void | drawImageButton (Graphics &, Image *, int imageX, int imageY, int imageW, int imageH, const Colour &overlayColour, float imageOpacity, ImageButton &) override
void | drawTableHeaderBackground (Graphics &, TableHeaderComponent &) override
void | drawTableHeaderColumn (Graphics &, TableHeaderComponent &, const String &columnName, int columnId, int width, int height, bool isMouseOver, bool isMouseDown, int columnFlags) override
void | paintToolbarBackground (Graphics &, int width, int height, Toolbar &) override
Button * | createToolbarMissingItemsButton (Toolbar &) override
void | paintToolbarButtonBackground (Graphics &, int width, int height, bool isMouseOver, bool isMouseDown, ToolbarItemComponent &) override
void | paintToolbarButtonLabel (Graphics &, int x, int y, int width, int height, const String &text, ToolbarItemComponent &) override
void | drawPropertyPanelSectionHeader (Graphics &, const String &name, bool isOpen, int width, int height) override
void | drawPropertyComponentBackground (Graphics &, int width, int height, PropertyComponent &) override
void | drawPropertyComponentLabel (Graphics &, int width, int height, PropertyComponent &) override
Rectangle< int > | getPropertyComponentContentPosition (PropertyComponent &) override
int | getPropertyPanelSectionHeaderHeight (const String &sectionTitle) override
void | drawCallOutBoxBackground (CallOutBox &, Graphics &, const Path &path, Image &cachedImage) override
int | getCallOutBoxBorderSize (const CallOutBox &) override
float | getCallOutBoxCornerSize (const CallOutBox &) override
void | drawLevelMeter (Graphics &, int width, int height, float level) override
void | drawKeymapChangeButton (Graphics &, int width, int height, Button &, const String &keyDescription) override
Font | getSidePanelTitleFont (SidePanel &) override
Justification | getSidePanelTitleJustification (SidePanel &) override
Path | getSidePanelDismissButtonShape (SidePanel &) override
Public Member Functions inherited from LookAndFeel
| LookAndFeel ()
| Creates the default JUCE look and feel. More...
| ~LookAndFeel () override
| Destructor. More...
Colour | findColour (int colourId) const noexcept
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourId, Colour colour) noexcept
| Registers a colour to be used for a particular purpose. More...
bool | isColourSpecified (int colourId) const noexcept
| Returns true if the specified colour ID has been explicitly set using the setColour() method. More...
virtual Typeface::Ptr | getTypefaceForFont (const Font &)
| Returns the typeface that should be used for a given font. More...
void | setDefaultSansSerifTypeface (Typeface::Ptr newDefaultTypeface)
| Allows you to supply a default typeface that will be returned as the default sans-serif font. More...
void | setDefaultSansSerifTypefaceName (const String &newName)
| Allows you to change the default sans-serif font. More...
void | setUsingNativeAlertWindows (bool shouldUseNativeAlerts)
| Sets whether native alert windows (if available) or standard JUCE AlertWindows drawn with AlertWindow::LookAndFeelMethods will be used. More...
bool | isUsingNativeAlertWindows ()
| Returns true if native alert windows will be used (if available). More...
virtual MouseCursor | getMouseCursorFor (Component &)
| Override this to get the chance to swap a component's mouse cursor for a customised one. More...
virtual std::unique_ptr< LowLevelGraphicsContext > | createGraphicsContext (const Image &imageToRenderOn, Point< int > origin, const RectangleList< int > &initialClip)
| Creates a new graphics context object. More...
virtual void | playAlertSound ()
| Plays the system's default 'beep' noise, to alert the user about something very important. More...
Public Member Functions inherited from ScrollBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from Button::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ImageButton::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TextEditor::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from FileBrowserComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TreeView::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from BubbleComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from AlertWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from PopupMenu::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ComboBox::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from Label::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from Slider::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ResizableWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from DocumentWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TooltipWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TabbedButtonBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from PropertyComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from FilenameComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from GroupComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TableHeaderComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from CallOutBox::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from Toolbar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ConcertinaPanel::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ProgressBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from StretchableLayoutResizerBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::KeyMappingEditorComponentMethods
virtual | ~KeyMappingEditorComponentMethods ()=default
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::AudioDeviceSelectorComponentMethods
virtual | ~AudioDeviceSelectorComponentMethods ()=default
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::LassoComponentMethods
virtual | ~LassoComponentMethods ()=default
Public Member Functions inherited from SidePanel::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default

## Static Public Member Functions
static void | drawBevel (Graphics &, int x, int y, int width, int height, int bevelThickness, const Colour &topLeftColour=Colours::white, const Colour &bottomRightColour=Colours::black, bool useGradient=true, bool sharpEdgeOnOutside=true)
| Draws a 3D raised (or indented) bevel using two colours. More...
static void | drawGlassSphere (Graphics &, float x, float y, float diameter, const Colour &, float outlineThickness) noexcept
| Utility function to draw a shiny, glassy circle (for round LED-type buttons). More...
static void | drawGlassPointer (Graphics &, float x, float y, float diameter, const Colour &, float outlineThickness, int direction) noexcept
static void | drawGlassLozenge (Graphics &, float x, float y, float width, float height, const Colour &, float outlineThickness, float cornerSize, bool flatOnLeft, bool flatOnRight, bool flatOnTop, bool flatOnBottom) noexcept
| Utility function to draw a shiny, glassy oblong (for text buttons). More...
Static Public Member Functions inherited from LookAndFeel
static LookAndFeel & | getDefaultLookAndFeel () noexcept
| Returns the current default look-and-feel for a component to use when it hasn't got one explicitly set. More...
static void | setDefaultLookAndFeel (LookAndFeel *newDefaultLookAndFeel) noexcept
| Changes the default look-and-feel. More...

## Detailed Description

This LookAndFeel subclass implements the juce style from around 2008-12.

See also
  LookAndFeel, LookAndFeel_V1, LookAndFeel_V3

## Constructor & Destructor Documentation

## ◆ LookAndFeel_V2()

LookAndFeel_V2::LookAndFeel_V2 | ( |  | ) |

## ◆ ~LookAndFeel_V2()

LookAndFeel_V2::~LookAndFeel_V2 | ( |  | ) |
| override

## Member Function Documentation

## ◆ drawButtonBackground()

void LookAndFeel_V2::drawButtonBackground | ( | Graphics & | ,
|  | Button & | ,
|  | const Colour & | backgroundColour,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| overridevirtual

Implements Button::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ getTextButtonFont()

Font LookAndFeel_V2::getTextButtonFont | ( | TextButton & | ,
|  | int | buttonHeight
| ) |  |
| overridevirtual

Implements Button::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawButtonText()

void LookAndFeel_V2::drawButtonText | ( | Graphics & | ,
|  | TextButton & | ,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| overridevirtual

Draws the text for a TextButton.

Implements Button::LookAndFeelMethods.

## ◆ getTextButtonWidthToFitText()

int LookAndFeel_V2::getTextButtonWidthToFitText | ( | TextButton & | ,
|  | int | buttonHeight
| ) |  |
| overridevirtual

Implements Button::LookAndFeelMethods.

## ◆ drawToggleButton()

void LookAndFeel_V2::drawToggleButton | ( | Graphics & | ,
|  | ToggleButton & | ,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| overridevirtual

Draws the contents of a standard ToggleButton.

Implements Button::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ changeToggleButtonWidthToFitText()

void LookAndFeel_V2::changeToggleButtonWidthToFitText | ( | ToggleButton & |  | ) |
| overridevirtual

Implements Button::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawTickBox()

void LookAndFeel_V2::drawTickBox | ( | Graphics & | ,
|  | Component & | ,
|  | float | x,
|  | float | y,
|  | float | w,
|  | float | h,
|  | bool | ticked,
|  | bool | isEnabled,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| overridevirtual

Implements Button::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawDrawableButton()

void LookAndFeel_V2::drawDrawableButton | ( | Graphics & | ,
|  | DrawableButton & | ,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| overridevirtual

Implements Button::LookAndFeelMethods.

## ◆ createAlertWindow()

AlertWindow * LookAndFeel_V2::createAlertWindow | ( | const String & | title,
|  | const String & | message,
|  | const String & | button1,
|  | const String & | button2,
|  | const String & | button3,
|  | MessageBoxIconType | iconType,
|  | int | numButtons,
|  | Component * | associatedComponent
| ) |  |
| overridevirtual

Implements AlertWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawAlertBox()

void LookAndFeel_V2::drawAlertBox | ( | Graphics & | ,
|  | AlertWindow & | ,
|  | const Rectangle< int > & | textArea,
|  | TextLayout & |
| ) |  |
| overridevirtual

Implements AlertWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getAlertBoxWindowFlags()

int LookAndFeel_V2::getAlertBoxWindowFlags | ( |  | ) |
| overridevirtual

Implements AlertWindow::LookAndFeelMethods.

## ◆ getWidthsForTextButtons()

Array< int > LookAndFeel_V2::getWidthsForTextButtons | ( | AlertWindow & | ,
|  | const Array< TextButton * > & |
| ) |  |
| overridevirtual

Implements AlertWindow::LookAndFeelMethods.

## ◆ getAlertWindowButtonHeight()

int LookAndFeel_V2::getAlertWindowButtonHeight | ( |  | ) |
| overridevirtual

Implements AlertWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getAlertWindowTitleFont()

Font LookAndFeel_V2::getAlertWindowTitleFont | ( |  | ) |
| overridevirtual

Override this function to supply a custom font for the alert window title.

This default implementation will use a boldened and slightly larger version of the alert window message font.

See also
  getAlertWindowMessageFont.

Implements AlertWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getAlertWindowMessageFont()

Font LookAndFeel_V2::getAlertWindowMessageFont | ( |  | ) |
| overridevirtual

Override this function to supply a custom font for the alert window message.

This default implementation will use the default font with height set to 15.0f.

See also
  getAlertWindowTitleFont

Implements AlertWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getAlertWindowFont()

Font LookAndFeel_V2::getAlertWindowFont | ( |  | ) |
| overridevirtual

Implements AlertWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawProgressBar()

void LookAndFeel_V2::drawProgressBar | ( | Graphics & | ,
|  | ProgressBar & | ,
|  | int | width,
|  | int | height,
|  | double | progress,
|  | const String & | textToShow
| ) |  |
| overridevirtual

Draws a progress bar.

If the progress value is less than 0 or greater than 1.0, this should draw a spinning bar that fills the whole space (i.e. to say that the app is still busy but the progress isn't known). It can use the current time as a basis for playing an animation.

(Used by progress bars in AlertWindow).

Implements ProgressBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawSpinningWaitAnimation()

void LookAndFeel_V2::drawSpinningWaitAnimation | ( | Graphics & | ,
|  | const Colour & | colour,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |
| overridevirtual

Draws a small image that spins to indicate that something's happening.

This method should use the current time to animate itself, so just keep repainting it every so often.

Implements LookAndFeel.

## ◆ isProgressBarOpaque()

bool LookAndFeel_V2::isProgressBarOpaque | ( | ProgressBar & |  | ) |
| overridevirtual

Implements ProgressBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ areScrollbarButtonsVisible()

bool LookAndFeel_V2::areScrollbarButtonsVisible | ( |  | ) |
| overridevirtual

Implements ScrollBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ drawScrollbarButton()

void LookAndFeel_V2::drawScrollbarButton | ( | Graphics & | g,
|  | ScrollBar & | scrollbar,
|  | int | width,
|  | int | height,
|  | int | buttonDirection,
|  | bool | isScrollbarVertical,
|  | bool | isMouseOverButton,
|  | bool | isButtonDown
| ) |  |
| overridevirtual

Draws one of the buttons on a scrollbar.

Parameters

  g | the context to draw into
  scrollbar | the bar itself
  width | the width of the button
  height | the height of the button
  buttonDirection | the direction of the button, where 0 = up, 1 = right, 2 = down, 3 = left
  isScrollbarVertical | true if it's a vertical bar, false if horizontal
  isMouseOverButton | whether the mouse is currently over the button (also true if it's held down)
  isButtonDown | whether the mouse button's held down

Implements ScrollBar::LookAndFeelMethods.

## ◆ drawScrollbar()

void LookAndFeel_V2::drawScrollbar | ( | Graphics & | g,
|  | ScrollBar & | scrollbar,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | bool | isScrollbarVertical,
|  | int | thumbStartPosition,
|  | int | thumbSize,
|  | bool | isMouseOver,
|  | bool | isMouseDown
| ) |  |
| overridevirtual

Draws the thumb area of a scrollbar.

Parameters

  g | the context to draw into
  scrollbar | the bar itself
  x | the x position of the left edge of the thumb area to draw in
  y | the y position of the top edge of the thumb area to draw in
  width | the width of the thumb area to draw in
  height | the height of the thumb area to draw in
  isScrollbarVertical | true if it's a vertical bar, false if horizontal
  thumbStartPosition | for vertical bars, the y coordinate of the top of the thumb, or its x position for horizontal bars
  thumbSize | for vertical bars, the height of the thumb, or its width for horizontal bars. This may be 0 if the thumb shouldn't be drawn.
  isMouseOver | whether the mouse is over the thumb area, also true if the mouse is currently dragging the thumb
  isMouseDown | whether the mouse is currently dragging the scrollbar

Implements ScrollBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ getScrollbarEffect()

ImageEffectFilter * LookAndFeel_V2::getScrollbarEffect | ( |  | ) |
| overridevirtual

Returns the component effect to use for a scrollbar.

Implements ScrollBar::LookAndFeelMethods.

## ◆ getMinimumScrollbarThumbSize()

int LookAndFeel_V2::getMinimumScrollbarThumbSize | ( | ScrollBar & |  | ) |
| overridevirtual

Returns the minimum length in pixels to use for a scrollbar thumb.

Implements ScrollBar::LookAndFeelMethods.

## ◆ getDefaultScrollbarWidth()

int LookAndFeel_V2::getDefaultScrollbarWidth | ( |  | ) |
| overridevirtual

Returns the default thickness to use for a scrollbar.

Implements ScrollBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getScrollbarButtonSize()

int LookAndFeel_V2::getScrollbarButtonSize | ( | ScrollBar & |  | ) |
| overridevirtual

Returns the length in pixels to use for a scrollbar button.

Implements ScrollBar::LookAndFeelMethods.

## ◆ getTickShape()

Path LookAndFeel_V2::getTickShape | ( | float | height | ) |
| overridevirtual

Returns a tick shape for use in yes/no boxes, etc.

Implements LookAndFeel.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ getCrossShape()

Path LookAndFeel_V2::getCrossShape | ( | float | height | ) |
| overridevirtual

Returns a cross shape for use in yes/no boxes, etc.

Implements LookAndFeel.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ drawTreeviewPlusMinusBox()

void LookAndFeel_V2::drawTreeviewPlusMinusBox | ( | Graphics & | ,
|  | const Rectangle< float > & | area,
|  | Colour | backgroundColour,
|  | bool | isOpen,
|  | bool | isMouseOver
| ) |  |
| overridevirtual

Implements TreeView::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ areLinesDrawnForTreeView()

bool LookAndFeel_V2::areLinesDrawnForTreeView | ( | TreeView & |  | ) |
| overridevirtual

Implements TreeView::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ getTreeViewIndentSize()

int LookAndFeel_V2::getTreeViewIndentSize | ( | TreeView & |  | ) |
| overridevirtual

Implements TreeView::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ fillTextEditorBackground()

void LookAndFeel_V2::fillTextEditorBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | TextEditor & |
| ) |  |
| overridevirtual

Implements TextEditor::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawTextEditorOutline()

void LookAndFeel_V2::drawTextEditorOutline | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | TextEditor & |
| ) |  |
| overridevirtual

Implements TextEditor::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ createCaretComponent()

CaretComponent * LookAndFeel_V2::createCaretComponent | ( | Component * | keyFocusOwner | ) |
| overridevirtual

Implements TextEditor::LookAndFeelMethods.

## ◆ getDefaultFolderImage()

const Drawable * LookAndFeel_V2::getDefaultFolderImage | ( |  | ) |
| overridevirtual

Implements FileBrowserComponent::LookAndFeelMethods.

## ◆ getDefaultDocumentFileImage()

const Drawable * LookAndFeel_V2::getDefaultDocumentFileImage | ( |  | ) |
| overridevirtual

Implements FileBrowserComponent::LookAndFeelMethods.

## ◆ createFileChooserHeaderText()

AttributedString LookAndFeel_V2::createFileChooserHeaderText | ( | const String & | title,
|  | const String & | instructions
| ) |  |
| overridevirtual

Implements FileBrowserComponent::LookAndFeelMethods.

## ◆ drawFileBrowserRow()

void LookAndFeel_V2::drawFileBrowserRow | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | const File & | file,
|  | const String & | filename,
|  | Image * | icon,
|  | const String & | fileSizeDescription,
|  | const String & | fileTimeDescription,
|  | bool | isDirectory,
|  | bool | isItemSelected,
|  | int | itemIndex,
|  | DirectoryContentsDisplayComponent & |
| ) |  |
| overridevirtual

Implements FileBrowserComponent::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ createFileBrowserGoUpButton()

Button * LookAndFeel_V2::createFileBrowserGoUpButton | ( |  | ) |
| overridevirtual

Implements FileBrowserComponent::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ layoutFileBrowserComponent()

void LookAndFeel_V2::layoutFileBrowserComponent | ( | FileBrowserComponent & | ,
|  | DirectoryContentsDisplayComponent * | ,
|  | FilePreviewComponent * | ,
|  | ComboBox * | currentPathBox,
|  | TextEditor * | filenameBox,
|  | Button * | goUpButton
| ) |  |
| overridevirtual

Implements FileBrowserComponent::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawBubble()

void LookAndFeel_V2::drawBubble | ( | Graphics & | ,
|  | BubbleComponent & | ,
|  | const Point< float > & | tip,
|  | const Rectangle< float > & | body
| ) |  |
| overridevirtual

Implements BubbleComponent::LookAndFeelMethods.

## ◆ drawLasso()

void LookAndFeel_V2::drawLasso | ( | Graphics & | ,
|  | Component & |
| ) |  |
| overridevirtual

Implements ExtraLookAndFeelBaseClasses::LassoComponentMethods.

## ◆ drawPopupMenuBackground()

void LookAndFeel_V2::drawPopupMenuBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height
| ) |  |
| overridevirtual

Fills the background of a popup menu component.

Reimplemented from PopupMenu::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ drawPopupMenuBackgroundWithOptions()

void LookAndFeel_V2::drawPopupMenuBackgroundWithOptions | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | const PopupMenu::Options & |
| ) |  |
| overridevirtual

Fills the background of a popup menu component.

Implements PopupMenu::LookAndFeelMethods.

## ◆ drawPopupMenuItem()

void LookAndFeel_V2::drawPopupMenuItem | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | bool | isSeparator,
|  | bool | isActive,
|  | bool | isHighlighted,
|  | bool | isTicked,
|  | bool | hasSubMenu,
|  | const String & | text,
|  | const String & | shortcutKeyText,
|  | const Drawable * | icon,
|  | const Colour * | textColour
| ) |  |
| overridevirtual

Draws one of the items in a popup menu.

Reimplemented from PopupMenu::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawPopupMenuItemWithOptions()

void LookAndFeel_V2::drawPopupMenuItemWithOptions | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | bool | isHighlighted,
|  | const PopupMenu::Item & | item,
|  | const PopupMenu::Options & |
| ) |  |
| overridevirtual

Draws one of the items in a popup menu.

Implements PopupMenu::LookAndFeelMethods.

## ◆ drawPopupMenuSectionHeader()

void LookAndFeel_V2::drawPopupMenuSectionHeader | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | const String & | sectionName
| ) |  |
| overridevirtual

Reimplemented from PopupMenu::LookAndFeelMethods.

## ◆ drawPopupMenuSectionHeaderWithOptions()

void LookAndFeel_V2::drawPopupMenuSectionHeaderWithOptions | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | const String & | sectionName,
|  | const PopupMenu::Options & |
| ) |  |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ getPopupMenuFont()

Font LookAndFeel_V2::getPopupMenuFont | ( |  | ) |
| overridevirtual

Returns the size and style of font to use in popup menus.

Implements PopupMenu::LookAndFeelMethods.

## ◆ drawPopupMenuUpDownArrow()

void LookAndFeel_V2::drawPopupMenuUpDownArrow | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isScrollUpArrow
| ) |  |
| overridevirtual

Reimplemented from PopupMenu::LookAndFeelMethods.

## ◆ drawPopupMenuUpDownArrowWithOptions()

void LookAndFeel_V2::drawPopupMenuUpDownArrowWithOptions | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isScrollUpArrow,
|  | const PopupMenu::Options & |
| ) |  |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ getIdealPopupMenuItemSize()

void LookAndFeel_V2::getIdealPopupMenuItemSize | ( | const String & | text,
|  | bool | isSeparator,
|  | int | standardMenuItemHeight,
|  | int & | idealWidth,
|  | int & | idealHeight
| ) |  |
| overridevirtual

Finds the best size for an item in a popup menu.

Reimplemented from PopupMenu::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getIdealPopupMenuItemSizeWithOptions()

void LookAndFeel_V2::getIdealPopupMenuItemSizeWithOptions | ( | const String & | text,
|  | bool | isSeparator,
|  | int | standardMenuItemHeight,
|  | int & | idealWidth,
|  | int & | idealHeight,
|  | const PopupMenu::Options & |
| ) |  |
| overridevirtual

Finds the best size for an item in a popup menu.

Implements PopupMenu::LookAndFeelMethods.

## ◆ getMenuWindowFlags()

int LookAndFeel_V2::getMenuWindowFlags | ( |  | ) |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ preparePopupMenuWindow()

void LookAndFeel_V2::preparePopupMenuWindow | ( | Component & |  | ) |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ drawMenuBarBackground()

void LookAndFeel_V2::drawMenuBarBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isMouseOverBar,
|  | MenuBarComponent & |
| ) |  |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4, and LookAndFeel_V3.

## ◆ getMenuBarItemWidth()

int LookAndFeel_V2::getMenuBarItemWidth | ( | MenuBarComponent & | ,
|  | int | itemIndex,
|  | const String & | itemText
| ) |  |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ getMenuBarFont()

Font LookAndFeel_V2::getMenuBarFont | ( | MenuBarComponent & | ,
|  | int | itemIndex,
|  | const String & | itemText
| ) |  |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ getDefaultMenuBarHeight()

int LookAndFeel_V2::getDefaultMenuBarHeight | ( |  | ) |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ drawMenuBarItem()

void LookAndFeel_V2::drawMenuBarItem | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | int | itemIndex,
|  | const String & | itemText,
|  | bool | isMouseOverItem,
|  | bool | isMenuOpen,
|  | bool | isMouseOverBar,
|  | MenuBarComponent & |
| ) |  |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getParentComponentForMenuOptions()

Component * LookAndFeel_V2::getParentComponentForMenuOptions | ( | const PopupMenu::Options & | options | ) |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ shouldPopupMenuScaleWithTargetComponent()

bool LookAndFeel_V2::shouldPopupMenuScaleWithTargetComponent | ( | const PopupMenu::Options & | options | ) |
| overridevirtual

Return true if you want your popup menus to scale with the target component's AffineTransform or scale factor.

Implements PopupMenu::LookAndFeelMethods.

## ◆ getPopupMenuBorderSize()

int LookAndFeel_V2::getPopupMenuBorderSize | ( |  | ) |
| overridevirtual

Reimplemented from PopupMenu::LookAndFeelMethods.

## ◆ getPopupMenuBorderSizeWithOptions()

int LookAndFeel_V2::getPopupMenuBorderSizeWithOptions | ( | const PopupMenu::Options & |  | ) |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ drawPopupMenuColumnSeparatorWithOptions()

void LookAndFeel_V2::drawPopupMenuColumnSeparatorWithOptions | ( | Graphics & | g,
|  | const Rectangle< int > & | bounds,
|  | const PopupMenu::Options & |
| ) |  |
| overridevirtual

Implement this to draw some custom decoration between the columns of the popup menu.

`getPopupMenuColumnSeparatorWidthWithOptions` must return a positive value in order to display the separator.

Implements PopupMenu::LookAndFeelMethods.

## ◆ getPopupMenuColumnSeparatorWidthWithOptions()

int LookAndFeel_V2::getPopupMenuColumnSeparatorWidthWithOptions | ( | const PopupMenu::Options & |  | ) |
| overridevirtual

Return the amount of space that should be left between popup menu columns.

Implements PopupMenu::LookAndFeelMethods.

## ◆ drawComboBox()

void LookAndFeel_V2::drawComboBox | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isMouseButtonDown,
|  | int | buttonX,
|  | int | buttonY,
|  | int | buttonW,
|  | int | buttonH,
|  | ComboBox & |
| ) |  |
| overridevirtual

Implements ComboBox::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4, and LookAndFeel_V3.

## ◆ getComboBoxFont()

Font LookAndFeel_V2::getComboBoxFont | ( | ComboBox & |  | ) |
| overridevirtual

Implements ComboBox::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ createComboBoxTextBox()

Label * LookAndFeel_V2::createComboBoxTextBox | ( | ComboBox & |  | ) |
| overridevirtual

Implements ComboBox::LookAndFeelMethods.

## ◆ positionComboBoxText()

void LookAndFeel_V2::positionComboBoxText | ( | ComboBox & | ,
|  | Label & |
| ) |  |
| overridevirtual

Implements ComboBox::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getOptionsForComboBoxPopupMenu()

PopupMenu::Options LookAndFeel_V2::getOptionsForComboBoxPopupMenu | ( | ComboBox & | ,
|  | Label & |
| ) |  |
| overridevirtual

Implements ComboBox::LookAndFeelMethods.

## ◆ drawComboBoxTextWhenNothingSelected()

void LookAndFeel_V2::drawComboBoxTextWhenNothingSelected | ( | Graphics & | ,
|  | ComboBox & | ,
|  | Label & |
| ) |  |
| overridevirtual

Implements ComboBox::LookAndFeelMethods.

## ◆ drawLabel()

void LookAndFeel_V2::drawLabel | ( | Graphics & | ,
|  | Label & |
| ) |  |
| overridevirtual

Implements Label::LookAndFeelMethods.

## ◆ getLabelFont()

Font LookAndFeel_V2::getLabelFont | ( | Label & |  | ) |
| overridevirtual

Implements Label::LookAndFeelMethods.

## ◆ getLabelBorderSize()

BorderSize< int > LookAndFeel_V2::getLabelBorderSize | ( | Label & |  | ) |
| overridevirtual

Implements Label::LookAndFeelMethods.

## ◆ drawLinearSlider()

void LookAndFeel_V2::drawLinearSlider | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPos,
|  | float | minSliderPos,
|  | float | maxSliderPos,
|  | const Slider::SliderStyle | ,
|  | Slider & |
| ) |  |
| overridevirtual

Implements Slider::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ drawLinearSliderBackground()

void LookAndFeel_V2::drawLinearSliderBackground | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPos,
|  | float | minSliderPos,
|  | float | maxSliderPos,
|  | const Slider::SliderStyle | ,
|  | Slider & |
| ) |  |
| overridevirtual

Implements Slider::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ drawLinearSliderThumb()

void LookAndFeel_V2::drawLinearSliderThumb | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPos,
|  | float | minSliderPos,
|  | float | maxSliderPos,
|  | const Slider::SliderStyle | ,
|  | Slider & |
| ) |  |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ drawRotarySlider()

void LookAndFeel_V2::drawRotarySlider | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPosProportional,
|  | float | rotaryStartAngle,
|  | float | rotaryEndAngle,
|  | Slider & |
| ) |  |
| overridevirtual

Implements Slider::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getSliderThumbRadius()

int LookAndFeel_V2::getSliderThumbRadius | ( | Slider & |  | ) |
| overridevirtual

Implements Slider::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ createSliderButton()

Button * LookAndFeel_V2::createSliderButton | ( | Slider & | ,
|  | bool | isIncrement
| ) |  |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ createSliderTextBox()

Label * LookAndFeel_V2::createSliderTextBox | ( | Slider & |  | ) |
| overridevirtual

Implements Slider::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getSliderEffect()

ImageEffectFilter * LookAndFeel_V2::getSliderEffect | ( | Slider & |  | ) |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ getSliderPopupFont()

Font LookAndFeel_V2::getSliderPopupFont | ( | Slider & |  | ) |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ getSliderPopupPlacement()

int LookAndFeel_V2::getSliderPopupPlacement | ( | Slider & |  | ) |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ getSliderLayout()

Slider::SliderLayout LookAndFeel_V2::getSliderLayout | ( | Slider & |  | ) |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ getTooltipBounds()

Rectangle< int > LookAndFeel_V2::getTooltipBounds | ( | const String & | tipText,
|  | Point< int > | screenPos,
|  | Rectangle< int > | parentArea
| ) |  |
| overridevirtual

returns the bounds for a tooltip at the given screen coordinate, constrained within the given desktop area.

Implements TooltipWindow::LookAndFeelMethods.

## ◆ drawTooltip()

void LookAndFeel_V2::drawTooltip | ( | Graphics & | ,
|  | const String & | text,
|  | int | width,
|  | int | height
| ) |  |
| overridevirtual

Implements TooltipWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ createFilenameComponentBrowseButton()

Button * LookAndFeel_V2::createFilenameComponentBrowseButton | ( | const String & | text | ) |
| overridevirtual

Implements FilenameComponent::LookAndFeelMethods.

## ◆ layoutFilenameComponent()

void LookAndFeel_V2::layoutFilenameComponent | ( | FilenameComponent & | ,
|  | ComboBox * | filenameBox,
|  | Button * | browseButton
| ) |  |
| overridevirtual

Implements FilenameComponent::LookAndFeelMethods.

## ◆ drawConcertinaPanelHeader()

void LookAndFeel_V2::drawConcertinaPanelHeader | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | bool | isMouseOver,
|  | bool | isMouseDown,
|  | ConcertinaPanel & | ,
|  | Component & | panel
| ) |  |
| overridevirtual

Implements ConcertinaPanel::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ drawCornerResizer()

void LookAndFeel_V2::drawCornerResizer | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | bool | isMouseOver,
|  | bool | isMouseDragging
| ) |  |
| overridevirtual

Implements ResizableWindow::LookAndFeelMethods.

## ◆ drawResizableFrame()

void LookAndFeel_V2::drawResizableFrame | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | const BorderSize< int > & |
| ) |  |
| overridevirtual

Implements ResizableWindow::LookAndFeelMethods.

## ◆ fillResizableWindowBackground()

void LookAndFeel_V2::fillResizableWindowBackground | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | const BorderSize< int > & | ,
|  | ResizableWindow & |
| ) |  |
| overridevirtual

Implements ResizableWindow::LookAndFeelMethods.

## ◆ drawResizableWindowBorder()

void LookAndFeel_V2::drawResizableWindowBorder | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | const BorderSize< int > & | border,
|  | ResizableWindow & |
| ) |  |
| overridevirtual

Implements ResizableWindow::LookAndFeelMethods.

## ◆ drawDocumentWindowTitleBar()

void LookAndFeel_V2::drawDocumentWindowTitleBar | ( | DocumentWindow & | ,
|  | Graphics & | ,
|  | int | w,
|  | int | h,
|  | int | titleSpaceX,
|  | int | titleSpaceW,
|  | const Image * | icon,
|  | bool | drawTitleTextOnLeft
| ) |  |
| overridevirtual

Implements DocumentWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ createDocumentWindowButton()

Button * LookAndFeel_V2::createDocumentWindowButton | ( | int | buttonType | ) |
| overridevirtual

Implements DocumentWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ positionDocumentWindowButtons()

void LookAndFeel_V2::positionDocumentWindowButtons | ( | DocumentWindow & | ,
|  | int | titleBarX,
|  | int | titleBarY,
|  | int | titleBarW,
|  | int | titleBarH,
|  | Button * | minimiseButton,
|  | Button * | maximiseButton,
|  | Button * | closeButton,
|  | bool | positionTitleBarButtonsOnLeft
| ) |  |
| overridevirtual

Implements DocumentWindow::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ createDropShadowerForComponent()

std::unique_ptr< DropShadower > LookAndFeel_V2::createDropShadowerForComponent | ( | Component & |  | ) |
| overridevirtual

Creates a drop-shadower for a given component, if required.

See also
  DropShadower

Implements LookAndFeel.

## ◆ createFocusOutlineForComponent()

std::unique_ptr< FocusOutline > LookAndFeel_V2::createFocusOutlineForComponent | ( | Component & |  | ) |
| overridevirtual

Creates a focus outline for a given component, if required.

See also
  FocusOutline

Implements LookAndFeel.

## ◆ drawStretchableLayoutResizerBar()

void LookAndFeel_V2::drawStretchableLayoutResizerBar | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | bool | isVerticalBar,
|  | bool | isMouseOver,
|  | bool | isMouseDragging
| ) |  |
| overridevirtual

Implements StretchableLayoutResizerBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3, and LookAndFeel_V4.

## ◆ drawGroupComponentOutline()

void LookAndFeel_V2::drawGroupComponentOutline | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | const String & | text,
|  | const Justification & | ,
|  | GroupComponent & |
| ) |  |
| overridevirtual

Implements GroupComponent::LookAndFeelMethods.

## ◆ getTabButtonSpaceAroundImage()

int LookAndFeel_V2::getTabButtonSpaceAroundImage | ( |  | ) |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ getTabButtonOverlap()

int LookAndFeel_V2::getTabButtonOverlap | ( | int | tabDepth | ) |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ getTabButtonBestWidth()

int LookAndFeel_V2::getTabButtonBestWidth | ( | TabBarButton & | ,
|  | int | tabDepth
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

## ◆ getTabButtonExtraComponentBounds()

Rectangle< int > LookAndFeel_V2::getTabButtonExtraComponentBounds | ( | const TabBarButton & | ,
|  | Rectangle< int > & | textArea,
|  | Component & | extraComp
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

## ◆ drawTabButton()

void LookAndFeel_V2::drawTabButton | ( | TabBarButton & | ,
|  | Graphics & | ,
|  | bool | isMouseOver,
|  | bool | isMouseDown
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ getTabButtonFont()

Font LookAndFeel_V2::getTabButtonFont | ( | TabBarButton & | ,
|  | float | height
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

## ◆ drawTabButtonText()

void LookAndFeel_V2::drawTabButtonText | ( | TabBarButton & | ,
|  | Graphics & | ,
|  | bool | isMouseOver,
|  | bool | isMouseDown
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

## ◆ drawTabbedButtonBarBackground()

void LookAndFeel_V2::drawTabbedButtonBarBackground | ( | TabbedButtonBar & | ,
|  | Graphics & |
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

## ◆ drawTabAreaBehindFrontButton()

void LookAndFeel_V2::drawTabAreaBehindFrontButton | ( | TabbedButtonBar & | ,
|  | Graphics & | ,
|  | int | w,
|  | int | h
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ createTabButtonShape()

void LookAndFeel_V2::createTabButtonShape | ( | TabBarButton & | ,
|  | Path & | ,
|  | bool | isMouseOver,
|  | bool | isMouseDown
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

## ◆ fillTabButtonShape()

void LookAndFeel_V2::fillTabButtonShape | ( | TabBarButton & | ,
|  | Graphics & | ,
|  | const Path & | ,
|  | bool | isMouseOver,
|  | bool | isMouseDown
| ) |  |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

## ◆ createTabBarExtrasButton()

Button * LookAndFeel_V2::createTabBarExtrasButton | ( |  | ) |
| overridevirtual

Implements TabbedButtonBar::LookAndFeelMethods.

## ◆ drawImageButton()

void LookAndFeel_V2::drawImageButton | ( | Graphics & | ,
|  | Image * | ,
|  | int | imageX,
|  | int | imageY,
|  | int | imageW,
|  | int | imageH,
|  | const Colour & | overlayColour,
|  | float | imageOpacity,
|  | ImageButton & |
| ) |  |
| overridevirtual

Implements ImageButton::LookAndFeelMethods.

## ◆ drawTableHeaderBackground()

void LookAndFeel_V2::drawTableHeaderBackground | ( | Graphics & | ,
|  | TableHeaderComponent & |
| ) |  |
| overridevirtual

Implements TableHeaderComponent::LookAndFeelMethods.

Reimplemented in LookAndFeel_V3.

## ◆ drawTableHeaderColumn()

void LookAndFeel_V2::drawTableHeaderColumn | ( | Graphics & | ,
|  | TableHeaderComponent & | ,
|  | const String & | columnName,
|  | int | columnId,
|  | int | width,
|  | int | height,
|  | bool | isMouseOver,
|  | bool | isMouseDown,
|  | int | columnFlags
| ) |  |
| overridevirtual

Implements TableHeaderComponent::LookAndFeelMethods.

## ◆ paintToolbarBackground()

void LookAndFeel_V2::paintToolbarBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | Toolbar & |
| ) |  |
| overridevirtual

Implements Toolbar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ createToolbarMissingItemsButton()

Button * LookAndFeel_V2::createToolbarMissingItemsButton | ( | Toolbar & |  | ) |
| overridevirtual

Implements Toolbar::LookAndFeelMethods.

## ◆ paintToolbarButtonBackground()

void LookAndFeel_V2::paintToolbarButtonBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isMouseOver,
|  | bool | isMouseDown,
|  | ToolbarItemComponent & |
| ) |  |
| overridevirtual

Implements Toolbar::LookAndFeelMethods.

## ◆ paintToolbarButtonLabel()

void LookAndFeel_V2::paintToolbarButtonLabel | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | const String & | text,
|  | ToolbarItemComponent & |
| ) |  |
| overridevirtual

Implements Toolbar::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawPropertyPanelSectionHeader()

void LookAndFeel_V2::drawPropertyPanelSectionHeader | ( | Graphics & | ,
|  | const String & | name,
|  | bool | isOpen,
|  | int | width,
|  | int | height
| ) |  |
| overridevirtual

Implements PropertyComponent::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawPropertyComponentBackground()

void LookAndFeel_V2::drawPropertyComponentBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | PropertyComponent & |
| ) |  |
| overridevirtual

Implements PropertyComponent::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawPropertyComponentLabel()

void LookAndFeel_V2::drawPropertyComponentLabel | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | PropertyComponent & |
| ) |  |
| overridevirtual

Implements PropertyComponent::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getPropertyComponentContentPosition()

Rectangle< int > LookAndFeel_V2::getPropertyComponentContentPosition | ( | PropertyComponent & |  | ) |
| overridevirtual

Implements PropertyComponent::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getPropertyPanelSectionHeaderHeight()

int LookAndFeel_V2::getPropertyPanelSectionHeaderHeight | ( | const String & | sectionTitle | ) |
| overridevirtual

Implements PropertyComponent::LookAndFeelMethods.

## ◆ drawCallOutBoxBackground()

void LookAndFeel_V2::drawCallOutBoxBackground | ( | CallOutBox & | ,
|  | Graphics & | ,
|  | const Path & | path,
|  | Image & | cachedImage
| ) |  |
| overridevirtual

Implements CallOutBox::LookAndFeelMethods.

Reimplemented in LookAndFeel_V4.

## ◆ getCallOutBoxBorderSize()

int LookAndFeel_V2::getCallOutBoxBorderSize | ( | const CallOutBox & |  | ) |
| overridevirtual

Implements CallOutBox::LookAndFeelMethods.

## ◆ getCallOutBoxCornerSize()

float LookAndFeel_V2::getCallOutBoxCornerSize | ( | const CallOutBox & |  | ) |
| overridevirtual

Implements CallOutBox::LookAndFeelMethods.

## ◆ drawLevelMeter()

void LookAndFeel_V2::drawLevelMeter | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | float | level
| ) |  |
| overridevirtual

Implements ExtraLookAndFeelBaseClasses::AudioDeviceSelectorComponentMethods.

Reimplemented in LookAndFeel_V4.

## ◆ drawKeymapChangeButton()

void LookAndFeel_V2::drawKeymapChangeButton | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | Button & | ,
|  | const String & | keyDescription
| ) |  |
| overridevirtual

Implements ExtraLookAndFeelBaseClasses::KeyMappingEditorComponentMethods.

Reimplemented in LookAndFeel_V3.

## ◆ getSidePanelTitleFont()

Font LookAndFeel_V2::getSidePanelTitleFont | ( | SidePanel & |  | ) |
| overridevirtual

Implements SidePanel::LookAndFeelMethods.

## ◆ getSidePanelTitleJustification()

Justification LookAndFeel_V2::getSidePanelTitleJustification | ( | SidePanel & |  | ) |
| overridevirtual

Implements SidePanel::LookAndFeelMethods.

## ◆ getSidePanelDismissButtonShape()

Path LookAndFeel_V2::getSidePanelDismissButtonShape | ( | SidePanel & |  | ) |
| overridevirtual

Implements SidePanel::LookAndFeelMethods.

## ◆ drawBevel()

static void LookAndFeel_V2::drawBevel | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | int | bevelThickness,
|  | const Colour & | topLeftColour = `Colours::white`,
|  | const Colour & | bottomRightColour = `Colours::black`,
|  | bool | useGradient = `true`,
|  | bool | sharpEdgeOnOutside = `true`
| ) |  |
| static

Draws a 3D raised (or indented) bevel using two colours.

The bevel is drawn inside the given rectangle, and greater bevel thicknesses extend inwards.

The top-left colour is used for the top- and left-hand edges of the bevel; the bottom-right colour is used for the bottom- and right-hand edges.

If useGradient is true, then the bevel fades out to make it look more curved and less angular. If sharpEdgeOnOutside is true, the outside of the bevel is sharp, and it fades towards the centre; if sharpEdgeOnOutside is false, then the centre edges are sharp and it fades towards the outside.

## ◆ drawGlassSphere()

static void LookAndFeel_V2::drawGlassSphere | ( | Graphics & | ,
|  | float | x,
|  | float | y,
|  | float | diameter,
|  | const Colour & | ,
|  | float | outlineThickness
| ) |  |
| staticnoexcept

Utility function to draw a shiny, glassy circle (for round LED-type buttons).

## ◆ drawGlassPointer()

static void LookAndFeel_V2::drawGlassPointer | ( | Graphics & | ,
|  | float | x,
|  | float | y,
|  | float | diameter,
|  | const Colour & | ,
|  | float | outlineThickness,
|  | int | direction
| ) |  |
| staticnoexcept

## ◆ drawGlassLozenge()

static void LookAndFeel_V2::drawGlassLozenge | ( | Graphics & | ,
|  | float | x,
|  | float | y,
|  | float | width,
|  | float | height,
|  | const Colour & | ,
|  | float | outlineThickness,
|  | float | cornerSize,
|  | bool | flatOnLeft,
|  | bool | flatOnRight,
|  | bool | flatOnTop,
|  | bool | flatOnBottom
| ) |  |
| staticnoexcept

Utility function to draw a shiny, glassy oblong (for text buttons).

The documentation for this class was generated from the following file:

- juce_LookAndFeel_V2.h